// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from novatel_gps_msgs:msg/Inscov.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__DETAIL__INSCOV__TRAITS_HPP_
#define NOVATEL_GPS_MSGS__MSG__DETAIL__INSCOV__TRAITS_HPP_

#include "novatel_gps_msgs/msg/detail/inscov__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'novatel_msg_header'
#include "novatel_gps_msgs/msg/detail/novatel_message_header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const novatel_gps_msgs::msg::Inscov & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: novatel_msg_header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "novatel_msg_header:\n";
    to_yaml(msg.novatel_msg_header, out, indentation + 2);
  }

  // member: week
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "week: ";
    value_to_yaml(msg.week, out);
    out << "\n";
  }

  // member: seconds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "seconds: ";
    value_to_yaml(msg.seconds, out);
    out << "\n";
  }

  // member: position_covariance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.position_covariance.size() == 0) {
      out << "position_covariance: []\n";
    } else {
      out << "position_covariance:\n";
      for (auto item : msg.position_covariance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: attitude_covariance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.attitude_covariance.size() == 0) {
      out << "attitude_covariance: []\n";
    } else {
      out << "attitude_covariance:\n";
      for (auto item : msg.attitude_covariance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: velocity_covariance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.velocity_covariance.size() == 0) {
      out << "velocity_covariance: []\n";
    } else {
      out << "velocity_covariance:\n";
      for (auto item : msg.velocity_covariance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const novatel_gps_msgs::msg::Inscov & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<novatel_gps_msgs::msg::Inscov>()
{
  return "novatel_gps_msgs::msg::Inscov";
}

template<>
inline const char * name<novatel_gps_msgs::msg::Inscov>()
{
  return "novatel_gps_msgs/msg/Inscov";
}

template<>
struct has_fixed_size<novatel_gps_msgs::msg::Inscov>
  : std::integral_constant<bool, has_fixed_size<novatel_gps_msgs::msg::NovatelMessageHeader>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<novatel_gps_msgs::msg::Inscov>
  : std::integral_constant<bool, has_bounded_size<novatel_gps_msgs::msg::NovatelMessageHeader>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<novatel_gps_msgs::msg::Inscov>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NOVATEL_GPS_MSGS__MSG__DETAIL__INSCOV__TRAITS_HPP_
