// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/Satellite.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/satellite__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
novatel_gps_msgs__msg__Satellite__init(novatel_gps_msgs__msg__Satellite * msg)
{
  if (!msg) {
    return false;
  }
  // prn
  // elevation
  // azimuth
  // snr
  return true;
}

void
novatel_gps_msgs__msg__Satellite__fini(novatel_gps_msgs__msg__Satellite * msg)
{
  if (!msg) {
    return;
  }
  // prn
  // elevation
  // azimuth
  // snr
}

bool
novatel_gps_msgs__msg__Satellite__are_equal(const novatel_gps_msgs__msg__Satellite * lhs, const novatel_gps_msgs__msg__Satellite * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // prn
  if (lhs->prn != rhs->prn) {
    return false;
  }
  // elevation
  if (lhs->elevation != rhs->elevation) {
    return false;
  }
  // azimuth
  if (lhs->azimuth != rhs->azimuth) {
    return false;
  }
  // snr
  if (lhs->snr != rhs->snr) {
    return false;
  }
  return true;
}

bool
novatel_gps_msgs__msg__Satellite__copy(
  const novatel_gps_msgs__msg__Satellite * input,
  novatel_gps_msgs__msg__Satellite * output)
{
  if (!input || !output) {
    return false;
  }
  // prn
  output->prn = input->prn;
  // elevation
  output->elevation = input->elevation;
  // azimuth
  output->azimuth = input->azimuth;
  // snr
  output->snr = input->snr;
  return true;
}

novatel_gps_msgs__msg__Satellite *
novatel_gps_msgs__msg__Satellite__create()
{
  novatel_gps_msgs__msg__Satellite * msg = (novatel_gps_msgs__msg__Satellite *)malloc(sizeof(novatel_gps_msgs__msg__Satellite));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__Satellite));
  bool success = novatel_gps_msgs__msg__Satellite__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__Satellite__destroy(novatel_gps_msgs__msg__Satellite * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__Satellite__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__Satellite__Sequence__init(novatel_gps_msgs__msg__Satellite__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__Satellite * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__Satellite *)calloc(size, sizeof(novatel_gps_msgs__msg__Satellite));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__Satellite__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__Satellite__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__Satellite__Sequence__fini(novatel_gps_msgs__msg__Satellite__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__Satellite__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__Satellite__Sequence *
novatel_gps_msgs__msg__Satellite__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__Satellite__Sequence * array = (novatel_gps_msgs__msg__Satellite__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__Satellite__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__Satellite__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__Satellite__Sequence__destroy(novatel_gps_msgs__msg__Satellite__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__Satellite__Sequence__fini(array);
  }
  free(array);
}

bool
novatel_gps_msgs__msg__Satellite__Sequence__are_equal(const novatel_gps_msgs__msg__Satellite__Sequence * lhs, const novatel_gps_msgs__msg__Satellite__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!novatel_gps_msgs__msg__Satellite__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
novatel_gps_msgs__msg__Satellite__Sequence__copy(
  const novatel_gps_msgs__msg__Satellite__Sequence * input,
  novatel_gps_msgs__msg__Satellite__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(novatel_gps_msgs__msg__Satellite);
    novatel_gps_msgs__msg__Satellite * data =
      (novatel_gps_msgs__msg__Satellite *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!novatel_gps_msgs__msg__Satellite__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          novatel_gps_msgs__msg__Satellite__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!novatel_gps_msgs__msg__Satellite__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
