// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from novatel_gps_msgs:msg/NovatelHeading2.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_HEADING2__TRAITS_HPP_
#define NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_HEADING2__TRAITS_HPP_

#include "novatel_gps_msgs/msg/detail/novatel_heading2__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'novatel_msg_header'
#include "novatel_gps_msgs/msg/detail/novatel_message_header__traits.hpp"
// Member 'extended_solution_status'
#include "novatel_gps_msgs/msg/detail/novatel_extended_solution_status__traits.hpp"
// Member 'signal_mask'
#include "novatel_gps_msgs/msg/detail/novatel_signal_mask__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const novatel_gps_msgs::msg::NovatelHeading2 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: novatel_msg_header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "novatel_msg_header:\n";
    to_yaml(msg.novatel_msg_header, out, indentation + 2);
  }

  // member: solution_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "solution_status: ";
    value_to_yaml(msg.solution_status, out);
    out << "\n";
  }

  // member: position_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_type: ";
    value_to_yaml(msg.position_type, out);
    out << "\n";
  }

  // member: baseline_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "baseline_length: ";
    value_to_yaml(msg.baseline_length, out);
    out << "\n";
  }

  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading: ";
    value_to_yaml(msg.heading, out);
    out << "\n";
  }

  // member: pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch: ";
    value_to_yaml(msg.pitch, out);
    out << "\n";
  }

  // member: heading_sigma
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_sigma: ";
    value_to_yaml(msg.heading_sigma, out);
    out << "\n";
  }

  // member: pitch_sigma
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch_sigma: ";
    value_to_yaml(msg.pitch_sigma, out);
    out << "\n";
  }

  // member: rover_station_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rover_station_id: ";
    value_to_yaml(msg.rover_station_id, out);
    out << "\n";
  }

  // member: master_station_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "master_station_id: ";
    value_to_yaml(msg.master_station_id, out);
    out << "\n";
  }

  // member: num_satellites_tracked
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_satellites_tracked: ";
    value_to_yaml(msg.num_satellites_tracked, out);
    out << "\n";
  }

  // member: num_satellites_used_in_solution
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_satellites_used_in_solution: ";
    value_to_yaml(msg.num_satellites_used_in_solution, out);
    out << "\n";
  }

  // member: num_satellites_above_elevation_mask_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_satellites_above_elevation_mask_angle: ";
    value_to_yaml(msg.num_satellites_above_elevation_mask_angle, out);
    out << "\n";
  }

  // member: num_satellites_above_elevation_mask_angle_l2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_satellites_above_elevation_mask_angle_l2: ";
    value_to_yaml(msg.num_satellites_above_elevation_mask_angle_l2, out);
    out << "\n";
  }

  // member: solution_source
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "solution_source: ";
    value_to_yaml(msg.solution_source, out);
    out << "\n";
  }

  // member: extended_solution_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "extended_solution_status:\n";
    to_yaml(msg.extended_solution_status, out, indentation + 2);
  }

  // member: signal_mask
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "signal_mask:\n";
    to_yaml(msg.signal_mask, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const novatel_gps_msgs::msg::NovatelHeading2 & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<novatel_gps_msgs::msg::NovatelHeading2>()
{
  return "novatel_gps_msgs::msg::NovatelHeading2";
}

template<>
inline const char * name<novatel_gps_msgs::msg::NovatelHeading2>()
{
  return "novatel_gps_msgs/msg/NovatelHeading2";
}

template<>
struct has_fixed_size<novatel_gps_msgs::msg::NovatelHeading2>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<novatel_gps_msgs::msg::NovatelHeading2>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<novatel_gps_msgs::msg::NovatelHeading2>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_HEADING2__TRAITS_HPP_
