// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/NovatelMessageHeader.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/novatel_message_header__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `message_name`
// Member `port`
// Member `gps_time_status`
#include "rosidl_runtime_c/string_functions.h"
// Member `receiver_status`
#include "novatel_gps_msgs/msg/detail/novatel_receiver_status__functions.h"

bool
novatel_gps_msgs__msg__NovatelMessageHeader__init(novatel_gps_msgs__msg__NovatelMessageHeader * msg)
{
  if (!msg) {
    return false;
  }
  // message_name
  if (!rosidl_runtime_c__String__init(&msg->message_name)) {
    novatel_gps_msgs__msg__NovatelMessageHeader__fini(msg);
    return false;
  }
  // port
  if (!rosidl_runtime_c__String__init(&msg->port)) {
    novatel_gps_msgs__msg__NovatelMessageHeader__fini(msg);
    return false;
  }
  // sequence_num
  // percent_idle_time
  // gps_time_status
  if (!rosidl_runtime_c__String__init(&msg->gps_time_status)) {
    novatel_gps_msgs__msg__NovatelMessageHeader__fini(msg);
    return false;
  }
  // gps_week_num
  // gps_seconds
  // receiver_status
  if (!novatel_gps_msgs__msg__NovatelReceiverStatus__init(&msg->receiver_status)) {
    novatel_gps_msgs__msg__NovatelMessageHeader__fini(msg);
    return false;
  }
  // receiver_software_version
  return true;
}

void
novatel_gps_msgs__msg__NovatelMessageHeader__fini(novatel_gps_msgs__msg__NovatelMessageHeader * msg)
{
  if (!msg) {
    return;
  }
  // message_name
  rosidl_runtime_c__String__fini(&msg->message_name);
  // port
  rosidl_runtime_c__String__fini(&msg->port);
  // sequence_num
  // percent_idle_time
  // gps_time_status
  rosidl_runtime_c__String__fini(&msg->gps_time_status);
  // gps_week_num
  // gps_seconds
  // receiver_status
  novatel_gps_msgs__msg__NovatelReceiverStatus__fini(&msg->receiver_status);
  // receiver_software_version
}

bool
novatel_gps_msgs__msg__NovatelMessageHeader__are_equal(const novatel_gps_msgs__msg__NovatelMessageHeader * lhs, const novatel_gps_msgs__msg__NovatelMessageHeader * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // message_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message_name), &(rhs->message_name)))
  {
    return false;
  }
  // port
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->port), &(rhs->port)))
  {
    return false;
  }
  // sequence_num
  if (lhs->sequence_num != rhs->sequence_num) {
    return false;
  }
  // percent_idle_time
  if (lhs->percent_idle_time != rhs->percent_idle_time) {
    return false;
  }
  // gps_time_status
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->gps_time_status), &(rhs->gps_time_status)))
  {
    return false;
  }
  // gps_week_num
  if (lhs->gps_week_num != rhs->gps_week_num) {
    return false;
  }
  // gps_seconds
  if (lhs->gps_seconds != rhs->gps_seconds) {
    return false;
  }
  // receiver_status
  if (!novatel_gps_msgs__msg__NovatelReceiverStatus__are_equal(
      &(lhs->receiver_status), &(rhs->receiver_status)))
  {
    return false;
  }
  // receiver_software_version
  if (lhs->receiver_software_version != rhs->receiver_software_version) {
    return false;
  }
  return true;
}

bool
novatel_gps_msgs__msg__NovatelMessageHeader__copy(
  const novatel_gps_msgs__msg__NovatelMessageHeader * input,
  novatel_gps_msgs__msg__NovatelMessageHeader * output)
{
  if (!input || !output) {
    return false;
  }
  // message_name
  if (!rosidl_runtime_c__String__copy(
      &(input->message_name), &(output->message_name)))
  {
    return false;
  }
  // port
  if (!rosidl_runtime_c__String__copy(
      &(input->port), &(output->port)))
  {
    return false;
  }
  // sequence_num
  output->sequence_num = input->sequence_num;
  // percent_idle_time
  output->percent_idle_time = input->percent_idle_time;
  // gps_time_status
  if (!rosidl_runtime_c__String__copy(
      &(input->gps_time_status), &(output->gps_time_status)))
  {
    return false;
  }
  // gps_week_num
  output->gps_week_num = input->gps_week_num;
  // gps_seconds
  output->gps_seconds = input->gps_seconds;
  // receiver_status
  if (!novatel_gps_msgs__msg__NovatelReceiverStatus__copy(
      &(input->receiver_status), &(output->receiver_status)))
  {
    return false;
  }
  // receiver_software_version
  output->receiver_software_version = input->receiver_software_version;
  return true;
}

novatel_gps_msgs__msg__NovatelMessageHeader *
novatel_gps_msgs__msg__NovatelMessageHeader__create()
{
  novatel_gps_msgs__msg__NovatelMessageHeader * msg = (novatel_gps_msgs__msg__NovatelMessageHeader *)malloc(sizeof(novatel_gps_msgs__msg__NovatelMessageHeader));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__NovatelMessageHeader));
  bool success = novatel_gps_msgs__msg__NovatelMessageHeader__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__NovatelMessageHeader__destroy(novatel_gps_msgs__msg__NovatelMessageHeader * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__NovatelMessageHeader__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__init(novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__NovatelMessageHeader * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__NovatelMessageHeader *)calloc(size, sizeof(novatel_gps_msgs__msg__NovatelMessageHeader));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__NovatelMessageHeader__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__NovatelMessageHeader__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__fini(novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__NovatelMessageHeader__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__NovatelMessageHeader__Sequence *
novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * array = (novatel_gps_msgs__msg__NovatelMessageHeader__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__NovatelMessageHeader__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__destroy(novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__fini(array);
  }
  free(array);
}

bool
novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__are_equal(const novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * lhs, const novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!novatel_gps_msgs__msg__NovatelMessageHeader__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
novatel_gps_msgs__msg__NovatelMessageHeader__Sequence__copy(
  const novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * input,
  novatel_gps_msgs__msg__NovatelMessageHeader__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(novatel_gps_msgs__msg__NovatelMessageHeader);
    novatel_gps_msgs__msg__NovatelMessageHeader * data =
      (novatel_gps_msgs__msg__NovatelMessageHeader *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!novatel_gps_msgs__msg__NovatelMessageHeader__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          novatel_gps_msgs__msg__NovatelMessageHeader__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!novatel_gps_msgs__msg__NovatelMessageHeader__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
