// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from novatel_gps_msgs:msg/NovatelReceiverStatus.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_RECEIVER_STATUS__TRAITS_HPP_
#define NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_RECEIVER_STATUS__TRAITS_HPP_

#include "novatel_gps_msgs/msg/detail/novatel_receiver_status__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const novatel_gps_msgs::msg::NovatelReceiverStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: original_status_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "original_status_code: ";
    value_to_yaml(msg.original_status_code, out);
    out << "\n";
  }

  // member: error_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "error_flag: ";
    value_to_yaml(msg.error_flag, out);
    out << "\n";
  }

  // member: temperature_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature_flag: ";
    value_to_yaml(msg.temperature_flag, out);
    out << "\n";
  }

  // member: voltage_supply_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "voltage_supply_flag: ";
    value_to_yaml(msg.voltage_supply_flag, out);
    out << "\n";
  }

  // member: antenna_powered
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "antenna_powered: ";
    value_to_yaml(msg.antenna_powered, out);
    out << "\n";
  }

  // member: antenna_is_open
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "antenna_is_open: ";
    value_to_yaml(msg.antenna_is_open, out);
    out << "\n";
  }

  // member: antenna_is_shorted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "antenna_is_shorted: ";
    value_to_yaml(msg.antenna_is_shorted, out);
    out << "\n";
  }

  // member: cpu_overload_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cpu_overload_flag: ";
    value_to_yaml(msg.cpu_overload_flag, out);
    out << "\n";
  }

  // member: com1_buffer_overrun
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "com1_buffer_overrun: ";
    value_to_yaml(msg.com1_buffer_overrun, out);
    out << "\n";
  }

  // member: com2_buffer_overrun
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "com2_buffer_overrun: ";
    value_to_yaml(msg.com2_buffer_overrun, out);
    out << "\n";
  }

  // member: com3_buffer_overrun
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "com3_buffer_overrun: ";
    value_to_yaml(msg.com3_buffer_overrun, out);
    out << "\n";
  }

  // member: usb_buffer_overrun
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "usb_buffer_overrun: ";
    value_to_yaml(msg.usb_buffer_overrun, out);
    out << "\n";
  }

  // member: rf1_agc_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rf1_agc_flag: ";
    value_to_yaml(msg.rf1_agc_flag, out);
    out << "\n";
  }

  // member: rf2_agc_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rf2_agc_flag: ";
    value_to_yaml(msg.rf2_agc_flag, out);
    out << "\n";
  }

  // member: almanac_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "almanac_flag: ";
    value_to_yaml(msg.almanac_flag, out);
    out << "\n";
  }

  // member: position_solution_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_solution_flag: ";
    value_to_yaml(msg.position_solution_flag, out);
    out << "\n";
  }

  // member: position_fixed_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_fixed_flag: ";
    value_to_yaml(msg.position_fixed_flag, out);
    out << "\n";
  }

  // member: clock_steering_status_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "clock_steering_status_enabled: ";
    value_to_yaml(msg.clock_steering_status_enabled, out);
    out << "\n";
  }

  // member: clock_model_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "clock_model_flag: ";
    value_to_yaml(msg.clock_model_flag, out);
    out << "\n";
  }

  // member: oemv_external_oscillator_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "oemv_external_oscillator_flag: ";
    value_to_yaml(msg.oemv_external_oscillator_flag, out);
    out << "\n";
  }

  // member: software_resource_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "software_resource_flag: ";
    value_to_yaml(msg.software_resource_flag, out);
    out << "\n";
  }

  // member: aux1_status_event_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aux1_status_event_flag: ";
    value_to_yaml(msg.aux1_status_event_flag, out);
    out << "\n";
  }

  // member: aux2_status_event_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aux2_status_event_flag: ";
    value_to_yaml(msg.aux2_status_event_flag, out);
    out << "\n";
  }

  // member: aux3_status_event_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aux3_status_event_flag: ";
    value_to_yaml(msg.aux3_status_event_flag, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const novatel_gps_msgs::msg::NovatelReceiverStatus & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<novatel_gps_msgs::msg::NovatelReceiverStatus>()
{
  return "novatel_gps_msgs::msg::NovatelReceiverStatus";
}

template<>
inline const char * name<novatel_gps_msgs::msg::NovatelReceiverStatus>()
{
  return "novatel_gps_msgs/msg/NovatelReceiverStatus";
}

template<>
struct has_fixed_size<novatel_gps_msgs::msg::NovatelReceiverStatus>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<novatel_gps_msgs::msg::NovatelReceiverStatus>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<novatel_gps_msgs::msg::NovatelReceiverStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_RECEIVER_STATUS__TRAITS_HPP_
