// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from novatel_gps_msgs:msg/Trackstat.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__DETAIL__TRACKSTAT__TRAITS_HPP_
#define NOVATEL_GPS_MSGS__MSG__DETAIL__TRACKSTAT__TRAITS_HPP_

#include "novatel_gps_msgs/msg/detail/trackstat__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'channels'
#include "novatel_gps_msgs/msg/detail/trackstat_channel__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const novatel_gps_msgs::msg::Trackstat & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: solution_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "solution_status: ";
    value_to_yaml(msg.solution_status, out);
    out << "\n";
  }

  // member: position_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_type: ";
    value_to_yaml(msg.position_type, out);
    out << "\n";
  }

  // member: cutoff
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cutoff: ";
    value_to_yaml(msg.cutoff, out);
    out << "\n";
  }

  // member: channels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.channels.size() == 0) {
      out << "channels: []\n";
    } else {
      out << "channels:\n";
      for (auto item : msg.channels) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const novatel_gps_msgs::msg::Trackstat & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<novatel_gps_msgs::msg::Trackstat>()
{
  return "novatel_gps_msgs::msg::Trackstat";
}

template<>
inline const char * name<novatel_gps_msgs::msg::Trackstat>()
{
  return "novatel_gps_msgs/msg/Trackstat";
}

template<>
struct has_fixed_size<novatel_gps_msgs::msg::Trackstat>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<novatel_gps_msgs::msg::Trackstat>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<novatel_gps_msgs::msg::Trackstat>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NOVATEL_GPS_MSGS__MSG__DETAIL__TRACKSTAT__TRAITS_HPP_
